PostgreSQL 8.2.3 Documentation
Prev | Fast Backward |  | Fast Forward | Next

# TRUNCATE

## Name

TRUNCATE -- empty a table or set of tables

## Synopsis

    TRUNCATE [ TABLE ] name [, ...] [ CASCADE | RESTRICT ]

## Description

`TRUNCATE` quickly removes all rows from a set of tables. It has the same effect as an unqualified `DELETE` on each table, but since it does not actually scan the tables it is faster. This is most useful on large tables.

## Parameters

`name`

  The name (optionally schema-qualified) of a table to be truncated.

`CASCADE`

  Automatically truncate all tables that have foreign-key references to any of the named tables, or to any tables added to the group due to `CASCADE`.

`RESTRICT`

  Refuse to truncate if any of the tables have foreign-key references from tables that are not to be truncated. This is the default.

## Notes

Only the owner of a table may `TRUNCATE` it.

`TRUNCATE` cannot be used on a table that has foreign-key references from other tables, unless all such tables are also truncated in the same command. Checking validity in such cases would require table scans, and the whole point is not to do one. The `CASCADE` option can be used to automatically include all dependent tables — but be very careful when using this option, else you might lose data you did not intend to!

`TRUNCATE` will not run any user-defined `ON DELETE` triggers that might exist for the tables.

## Examples

Truncate the tables `bigtable` and `fattable`:

    TRUNCATE TABLE bigtable, fattable;

Truncate the table `othertable`, and cascade to any tables that are referencing `othertable` via foreign-key constraints:

    TRUNCATE othertable CASCADE;

## Compatibility

There is no `TRUNCATE` command in the SQL standard.

Prev | Home | Next
START TRANSACTION | Up | UNLISTEN